/***************************************************************************
 *   aio_admin.inc           Version 1.0 Release           Date: MAR/08/2004
 *
 *   RS All-In-One[AIO] Admin Menu (Small Include File)
 *
 *   By:    Rob Secord
 *   Alias: xeroblood (aka; sufferer)                     xeroblood@msn.com
 *          -dd| Digital Darkness        http://www.digitaldarkness.vze.com
 *
 *   Developed using:  AMX 0.9.8
 *   Tested On:        CS 1.6 (STEAM)
 *
 **************************************************************************/

#if defined _AIO_ADMIN_INCLUDED
  #endinput
#endif
#define _AIO_ADMIN_INCLUDED

// Uncomment if you get Loose Indentation Warnings on Compile..
//#pragma tabsize 0

// Uncomment for AIO-DEBUG messages in console..
//#define _DEBUG_MODE
//#define _DEBUG_MENU

// Change to your Desired Admin Access Level (Default ADMIN_LEVEL_C [flag 'o'])
#define AIO_LEVEL ADMIN_LEVEL_C


///////////////////////////////////////////////////////////
// Don't Change Anything beyond this point..
///////////////////////////////////////////////////////////

#define MAX_COMMANDS  32
#define MAX_PLAYERS   32
#define MAX_WEAPONS   32
#define MAX_CMD_CVARS 9
#define MAX_COLORS    8

// String Sizes
#define STR_T 32
#define STR_S 64
#define STR_M 128
#define STR_L 256
#define STR_X 512

// Command Offsets
#define BAD_CMDS  13
#define GOOD_CMDS 26
#define MISC_CMDS 32

// Menu Specific Settings
#define MENU_SIZE    256
#define MENU_DISPLAY 8

// set_task IDs
#define TASK_COMMON     1000
#define TASK_BSLAP      1100
#define TASK_GAG        1200
#define TASK_MUTE       1300
#define TASK_BLANKS     1400
#define TASK_FIRE       1500
#define TASK_ROCKET     1600
#define TASK_POISON     1700
#define TASK_GOD        1800
#define TASK_GRAV       1900
#define TASK_NOCLIP     2000
#define TASK_TURBO      2100
#define TASK_SILENT     2200
#define TASK_INVIS      2300
#define TASK_SPY        2400
#define TASK_NADES      2500
#define TASK_AMMO       2600
#define TASK_REVIVE     2700
#define TASK_EARS       2800


#define AIO_EMPTY   (-1)

// Bad Commands
#define AIO_BAN     (1<<0)
#define AIO_KICK    (1<<1)
#define AIO_SLAP    (1<<2)
#define AIO_BSLAP   (1<<3)
#define AIO_BURY    (1<<4)
#define AIO_GAG     (1<<5)
#define AIO_MUTE    (1<<6)
#define AIO_WARN    (1<<7)
#define AIO_BLANKS  (1<<8)
#define AIO_FIRE    (1<<9)
#define AIO_ROCKET  (1<<10)
#define AIO_STRIP   (1<<11)
#define AIO_POISON  (1<<12)

// Good Commands
#define AIO_GOD     (1<<13)
#define AIO_GRAV    (1<<14)
#define AIO_NOCLIP  (1<<15)
#define AIO_TURBO   (1<<16)
#define AIO_SILENT  (1<<17)
#define AIO_INVIS   (1<<18)
#define AIO_SPY     (1<<19)
#define AIO_NADES   (1<<20)
#define AIO_AMMO    (1<<21)
#define AIO_HP      (1<<22)
#define AIO_AP      (1<<23)
#define AIO_REVIVE  (1<<24)
#define AIO_EARS    (1<<25)

// Misc Commands
#define AIO_STACK   (1<<26)
#define AIO_GLOW    (1<<27)
#define AIO_CASH    (1<<28)
#define AIO_ADMIN   (1<<29)
#define AIO_FRAG    (1<<30)
#define AIO_WEAPON  (1<<31)


stock AIO_ReadFlags( p_szFlags[] )
{
    new i, j = 0
    new szBit[MAX_COMMANDS][] = { "a","b","c","d","e","f","g","h","i","j","k","l","m","n","o","p","q","r","s","t","u","v","w","x","y","z","1","2","3","4","5","6" }

    for( i = 0; i < MAX_COMMANDS; i++ )
        if( containi( p_szFlags, szBit[i] ) > AIO_EMPTY )
            j |= (1<<i)
    return j
}

stock bool:AIO_CommandEnabled( p_nFlag )
{
    new szFlags[MAX_COMMANDS+1]
    get_cvar_string( "sv_aio_command_flags", szFlags, MAX_COMMANDS )

    return ( AIO_ReadFlags(szFlags) & p_nFlag ) ? true : false
}

stock AIO_CommandType( p_nCmdIdx )
{
    if( p_nCmdIdx < 0 ) return p_nCmdIdx
    if( p_nCmdIdx < BAD_CMDS ) return BAD_CMDS
    if( p_nCmdIdx < GOOD_CMDS ) return GOOD_CMDS
    return MISC_CMDS
}

stock bool:AIO_HasCVAR( p_nFlag )
    return ( AIO_ReadFlags("acdfgijmnopqrstuvwxyz3456") & p_nFlag ) ? true : false

stock bool:AIO_GetSwitch( p_szArg[] )
    return ( equali( p_szArg, "on" ) || equali( p_szArg, "1" ) ) ? true : false

stock bool:AIO_PlayerHasImmunity( id, p_nCmdType )
{
    switch( p_nCmdType )
    {
        case BAD_CMDS:  if( !get_cvar_num("sv_aio_immunity_bad") )  return false
        case GOOD_CMDS: if( !get_cvar_num("sv_aio_immunity_good") ) return false
        case MISC_CMDS: if( !get_cvar_num("sv_aio_immunity_misc") ) return false
        case AIO_EMPTY: return false
    }
    if( access( id, ADMIN_IMMUNITY ) )
        return true
    return false
}

stock ExplodeString( output[][], const max, input[], const size, const delimiter )
{
    new nIdx = 0, l = strlen(input)
    new nLen = (1 + copyc( output[nIdx], size, input, delimiter ))
    while( (nLen < l) && (++nIdx < max) )
        nLen += (1 + copyc( output[nIdx], size, input[nLen], delimiter ))
    return
}

stock StripWeapons( id )
{
    new nWeapons[MAX_WEAPONS], nNum
    new szWeaponName[STR_T]
    new nOrigin[3]

    get_user_origin( id, nOrigin )
    nOrigin[2] -= 1024
    set_user_origin( id, nOrigin )

    get_user_weapons( id, nWeapons, nNum )
    for( new i = 0; i < nNum; i++ )
    {
        get_weaponname( nWeapons[i], szWeaponName, STR_T-1 )
        engclient_cmd( id, "drop", szWeaponName )
    }
    engclient_cmd( id, "weapon_knife" )

    nOrigin[2] += 1028
    set_user_origin( id, nOrigin )

    return
}

stock AnnounceAction( p_nAdminID, p_szAction[] )
{
    new szAdminName[STR_T]
    get_user_name( p_nAdminID, szAdminName, (STR_T-1) )
    show_activity( p_nAdminID, szAdminName, p_szAction )
    return
}
